package fxutil.doc;

/**
 * An interface with a method for saving a document (domain data container) to a location. This
 * allows various ways of saving or exporting domain data, to different locations and formats.
 *
 * @author hal
 *
 * @param <D> the document type
 * @param <L> the location type
 */
public interface IDocumentSaver<D, L> {
  /**
   * Saves the provided document to the provided location
   *
   * @param document the document to save
   * @param documentLocation the location to save to
   * @throws Exception when the document couldn't be saved
   */
  public void saveDocument(D document, L documentLocation) throws Exception;
}
