package simpleex.ui;

import com.fasterxml.jackson.databind.module.SimpleModule;
import fxutil.doc.IDocumentStorage;
import fxutil.doc.SimpleJsonFileStorageImpl;
import java.io.File;
import simpleex.core.LatLong;
import simpleex.core.LatLongs;
import simpleex.json.LatLongDeserializer;
import simpleex.json.LatLongSerializer;
import simpleex.json.LatLongsDeserializer;
import simpleex.json.LatLongsSerializer;

public class LatLongsStorage extends SimpleJsonFileStorageImpl<LatLongs>
    implements IDocumentStorage<File> {

  public LatLongsStorage() {
    super(LatLongs.class);
  }

  @Override
  protected void configureJacksonModule(final SimpleModule module) {
    module.addSerializer(LatLong.class, new LatLongSerializer());
    module.addSerializer(LatLongs.class, new LatLongsSerializer());
    module.addDeserializer(LatLong.class, new LatLongDeserializer());
    module.addDeserializer(LatLongs.class, new LatLongsDeserializer());
  }
}
